

      module system_mod
!
      contains
!
!


!
! (c) sparslab module name=realli_a
!
! purpose:
!  reallocate an integer array.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine realli_a(ja,arrsize,arrincr,new_arrsize,ierr)
!
! parameters
!
      integer arrsize,arrincr,new_arrsize,ierr
      integer, allocatable, dimension(:) :: ja
!
! internals
!
      integer minincr
      integer, allocatable, dimension(:) :: ja_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
!
! start of realli_a
!
      new_arrsize=arrsize+arrincr
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(ja_new(arrsize),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize,ja,1,ja_new,1)
      deallocate(ja)
      allocate(ja(new_arrsize),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize,ja_new,1,ja,1)
      deallocate(ja_new)
!
!  -- return
!
      return
!
! end of realli_a
!
      end subroutine realli_a
!


!

! (c) sparslab module name=reallr_a
!
! purpose:
!  reallocate an integer array.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine reallr_a(aa,arrsize,arrincr,new_arrsize,ierr)
!
! parameters
!
      use iotypes
      integer arrsize,arrincr,new_arrsize,ierr
      double precision, allocatable, dimension(:) :: aa
!
! internals
!
      integer minincr
      double precision, allocatable, dimension(:) :: aa_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
      character i_am*10
!
! start of reallr_a
!
      i_am='reallr_a'
!      write(2,*) 'arrsize',arrsize,arrincr
      new_arrsize=arrsize+arrincr
!      write(2,*) 'arrsize',new_arrsize
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
!      write(2,*) 'arrsize',minincr,new_arrsize
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(aa_new(arrsize),stat=ierr)
!      write(2,*) 'ierr',ierr
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize,aa,1,aa_new,1)
      deallocate(aa)
      allocate(aa(new_arrsize),stat=ierr)
!      write(2,*) 'ierr huhu',new_arrsize,ierr
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize,aa_new,1,aa,1)
      deallocate(aa_new)
!
!  -- return
!
      return
!
! end of reallr_a
!
      end subroutine reallr_a
!


! (c) sparslab module name=realli3_a
!
! purpose:
!  reallocate an integer array.
!  counts with additional nlast entries.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine realli3_a(ja,arrsize,arrincr,new_arrsize,nlast,ierr)
!
! parameters
!
      integer arrsize,arrincr,new_arrsize,ierr,nlast
      integer, allocatable, dimension(:) :: ja
!
! internals
!
      integer minincr
      integer, allocatable, dimension(:) :: ja_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
!
! start of realli3_a
!
      new_arrsize=arrsize+arrincr
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(ja_new(arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli3_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize+nlast,ja,1,ja_new,1)
      deallocate(ja)
      allocate(ja(new_arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','realli3_a', &
        ' Allocation failure',1605,2)
      call iwcopy(arrsize,ja_new,1,ja,1)
      call ivcopy_backward(nlast,ja_new,ja, &
        arrsize+1,new_arrsize+1)
      deallocate(ja_new)
!
!  -- return
!
      return
!
! end of realli3_a
!
      end subroutine realli3_a

! (c) sparslab module name=reallr3_a
!
! purpose:
!  reallocate an integer array.
!
! history:
!   original version for sparslab - tu - 16/04/2001.
!
      subroutine reallr3_a(aa,arrsize,arrincr,new_arrsize,nlast,ierr)
!
! parameters
!
      use iotypes
      integer arrsize,arrincr,new_arrsize,nlast,ierr
      double precision, allocatable, dimension(:) :: aa
!
! internals
!
      integer minincr
      double precision, allocatable, dimension(:) :: aa_new
      double precision minincrfactor
      parameter(minincrfactor=0.2d0)
      character i_am*10
!
! start of reallr3_a
!
      i_am='reallr3_a'
      new_arrsize=arrsize+arrincr
      if(new_arrsize.le.arrsize) then
        minincr=int(minincrfactor*dble(arrsize))
        new_arrsize=arrsize+minincr
        if(new_arrsize.le.arrsize) new_arrsize=huge(arrsize)
      end if
      allocate(aa_new(arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize+nlast,aa,1,aa_new,1)
      deallocate(aa)
      allocate(aa(new_arrsize+nlast),stat=ierr)
      if(ierr.ne.0) call err(ounit,1605,i_am,2)
      call dcopy(arrsize,aa_new,1,aa,1)
      call dvcopy_backward(nlast,aa_new,aa, &
        arrsize+1,new_arrsize+1)
      deallocate(aa_new)
!
!  -- return
!
      return
!
! end of reallr3_a
!
      end subroutine reallr3_a

!
      end module system_mod



      module matrix90
!
      use system_mod
!
      contains
!
!


! (c) sparslab module name=dsinit
!
! purpose:
!   initialization of dynamic data structures.
!   used typically for right-looking implementations
!   input matrix is in csr format.
!
! history:
!   original version for sparslab - tu - 13/04/1996.
!
! parameters:
!  ii  n  number of input matrix columns.
!  ii  m  number of input matrix rows.
!  gi  ia(n+1)/ja(ia(nn+1)-1) input matrix pattern
!  mo  ic(n)/jc(ic(n)+lenc(n)-1)/lenc(n)/ac(ic(n)+lenc(n)-1) output unit
!        matrix in dsc format.
!  ii  max_c  size of the vectors jc/ac.
!  mo  ir(n)/jr(ir(n)+lenr(n)-1)/lenr(n) output graph of unit matrix
!        in dsr format.
!  ii  max_r  size of the vector jr.
!  io  iendru  position of last entry in ir/jr/lenr.
!  io  iendlu  position of last entry in ic/jc/lenc/ac.
!  ii  idistr  type of the distribution pattern of the dsc format.
!  ii  idistc  type of the distribution pattern of the dsr format.
!  ii  ldist   distance between entries in ds* formats.
!
      subroutine dsinit(n,m,ia,ja,ic,jc,lenc,ac,max_c, &
        ir,jr,lenr,max_r, &
        iendru,iendlu,idistr,idistc,ldist,info)
!
! parameters
!
      integer n,m,max_r,max_c,ldist,info
      integer idistr,idistc,len
      integer :: ia(*),ja(*)
      integer, allocatable :: ir(:),jr(:),lenr(:),ic(:),jc(:),lenc(:)
      double precision, allocatable :: ac(:)
      integer iendru,iendlu
!
! include
!
! internals
!
      integer i,j,k,l,jstrt,jstop,nja
      integer izero
      double precision one
      parameter(izero=0,one=1.0d0)
!
! start of dsinit
!
!  -- test/set max_r and max_c
!
      info=0
      nja=ia(n+1)-1
      if(idistc.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(n+1)-1+n*ldist.ge.max_c-1) then
          max_c=2*nja+n*ldist
          deallocate(jc,ac)
          allocate(ac(max_c),jc(max_c),stat=ierr)
          if(ierr.ne.0) then
            info=1603
            return
          end if
        end if
      end if
      if(idistr.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(m+1)-1+n*ldist.ge.max_r-1) then
          max_r=2*nja+n*ldist
          deallocate(jr)
          allocate(jr(max_r),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','dsinit', &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
!
!  -- clear vectors for row and column indices
!
      call iwset(max_r-1,izero,jr,1)
      jr(max_r)=1
      call iwset(max_c-1,izero,jc,1)
      jc(max_c)=1
!
!  -- set column pointers
!  -- and insert an unit matrix stored by columns
!
      if(idistc.eq.0.or.idistc.eq.2) then
        if(idistc.eq.0) then
          len=1
          iendlu=len*(m-1)+1
        elseif(idistc.eq.2) then
          i=max_c/3
          len=max(1,i/m)
          iendlu=len*(m-1)+1
        end if
!
!    -- set initial values in the distance len
!
        k=1
        do i=1,n
          ic(i)=k
          lenc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len
        end do
      elseif(idistc.eq.1) then
        k=1
        do i=1,n
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=j-jstrt+1
              go to 130
            end if
          end do
 130      continue
          ic(i)=k
          lenc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len+ldist
        end do
        iendlu=k-len-ldist
      end if
      if(iendlu.ge.max_c-1) then
        stop 'internal error'
      end if
!
!  -- set row pointers
!  -- and insert row structure of the unit matrix
!
      if(idistr.eq.0.or.idistr.eq.2) then
        if(idistr.eq.0) then
          len=1
          iendru=len*(m-1)+1
        elseif(idistr.eq.2) then
          i=max_r/3
          len=max(1,i/m)
          iendru=len*(m-1)+1
        end if
!
!    -- set initial values
!
        k=1
        do i=1,m
          ir(i)=k
          lenr(i)=1
          jr(k)=i
          k=k+len
        end do
      elseif(idistr.eq.1) then
        k=1
        do i=1,m
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=jstop-j+1
              exit
            end if
          end do
          ir(i)=k
          lenr(i)=1
          jr(k)=i
          k=k+len+ldist
        end do
        iendru=k-len-ldist
      end if
      if(iendru.ge.max_r-1) then
        stop 'internal error'
      end if
!
!  -- return
!
      return
!
! end of dsinit
!
      end subroutine dsinit


! (c) sparslab module name=ds_eye_f90_mod
!
! purpose:
!   initialization of dynamic data structures for right-looking
!   ainv preconditioner.
!   input matrix is in csr format.
!
! history:
!   original version for sparslab - tu - 13/04/1996.
!
! parameters:
!  ii  n  number of input matrix columns.
!  ii  m  number of input matrix rows.
!  gi  ia(n+1)/ja(ia(nn+1)-1) input matrix graph.
!  mo  ic(n)/jc(ic(n)+kc(n)-1)/kc(n)/ac(ic(n)+kc(n)-1) output unit
!        matrix in dsc format.
!  ii  max_c  size of the vectors jc/ac.
!  mo  ir(n)/jr(ir(n)+kr(n)-1)/kr(n) output graph of unit matrix
!        in dsr format.
!  ii  max_r  size of the vector jr.
!  io  iendru  position of last entry in ir/jr/kr.
!  io  iendlu  position of last entry in ic/jc/kc/ac.
!  ii  idistr  type of the distribution pattern of the dsc format.
!  ii  idistc  type of the distribution pattern of the dsr format.
!  ii  lsize  size of the distance between entries in ds* formats.
!
!
! make_explicit_interface
!
      subroutine ds_eye_f90_mod(n,m,ia,ja,ic,jc,kc,ac,max_c, &
        ir,jr,kr,max_r,                                      &
        iendru,iendlu,idistr,idistc,lsize,ierr)
!
! parameters
!
      implicit none
      integer n,m,max_r,max_c,lsize,ierr
      integer idistr,idistc,len
      integer :: ia(*),ja(*)
      integer, allocatable :: ir(:),jr(:),kr(:),ic(:),jc(:),kc(:)
      double precision, allocatable :: ac(:)
      integer iendru,iendlu
!
! include
!
! internals
!
      integer i,j,k,l,jstrt,jstop,nja
      integer izero
      double precision one
      parameter(izero=0,one=1.0d0)
!
! start of ds_eye_f90_mod
!
!  -- test/set max_r and max_c
!
      nja=ia(n+1)-1
      if(idistc.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(n+1)-1+n*lsize.ge.max_c-1) then
          max_c=2*nja+n*lsize
          deallocate(ac)
          allocate(ac(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_f90_mod', &
            ' missing space to store the preconditioner',1603,2)
          deallocate(jc)
          allocate(jc(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_f90_mod', &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
      if(idistr.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(m+1)-1+n*lsize.ge.max_r-1) then
          max_r=2*nja+n*lsize
          deallocate(jr)
          allocate(jr(max_r),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_f90_mod', &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
!
!  -- clear vectors for row and column indices
!
      call iwset(max_r-1,izero,jr,1)
      jr(max_r)=1
      call iwset(max_c-1,izero,jc,1)
      jc(max_c)=1
!
!  -- set column pointers
!  -- and insert an unit matrix stored by columns
!
      if(idistc.eq.0.or.idistc.eq.2) then
        if(idistc.eq.0) then
          len=1
          iendlu=len*(m-1)+1
        elseif(idistc.eq.2) then
          i=max_c/3
          len=max(1,i/m)
          iendlu=len*(m-1)+1
        end if
!
!    -- set initial values in the distance len
!
        k=1
        do i=1,n
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len
        end do
      elseif(idistc.eq.1) then
        k=1
        do i=1,n
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=j-jstrt+1
              exit
            end if
          end do
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len+lsize
        end do
        iendlu=k-len-lsize
      end if
      if(iendlu.ge.max_c-1) then
        stop 'internal error'
      end if
!
!  -- set row pointers
!  -- and insert row structure of the unit matrix
!
      if(idistr.eq.0.or.idistr.eq.2) then
        if(idistr.eq.0) then
          len=1
          iendru=len*(m-1)+1
        elseif(idistr.eq.2) then
          i=max_r/3
          len=max(1,i/m)
          iendru=len*(m-1)+1
        end if
!
!    -- set initial values
!
        k=1
        do i=1,m
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len
        end do
      elseif(idistr.eq.1) then
        k=1
        do i=1,m
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=jstop-j+1
              exit
            end if
          end do
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len+lsize
        end do
        iendru=k-len-lsize
      end if
      if(iendru.ge.max_r-1) then
        stop 'internal error'
      end if
!
!  -- return
!
      return
!
! end of ds_eye_f90_mod
!
      end subroutine ds_eye_f90_mod


! (c) sparslab module name=ds_eye_mod
!
! purpose:
!   initialization of dynamic data structures for right-looking
!   ainv preconditioner.
!   input matrix is in csr format.
!
! history:
!   original version for sparslab - tu - 13/04/1996.
!
! parameters:
!  ii  n  number of input matrix columns.
!  ii  m  number of input matrix rows.
!  gi  ia(n+1)/ja(ia(nn+1)-1) input matrix graph.
!  mo  ic(n)/jc(ic(n)+kc(n)-1)/kc(n)/ac(ic(n)+kc(n)-1) output unit
!        matrix in dsc format.
!  ii  max_c  size of the vectors jc/ac.
!  mo  ir(n)/jr(ir(n)+kr(n)-1)/kr(n) output graph of unit matrix
!        in dsr format.
!  ii  max_r  size of the vector jr.
!  io  iendru  position of last entry in ir/jr/kr.
!  io  iendlu  position of last entry in ic/jc/kc/ac.
!  ii  idistr  type of the distribution pattern of the dsc format.
!  ii  idistc  type of the distribution pattern of the dsr format.
!  ii  lsize  size of the distance between entries in ds* formats.
!
      subroutine ds_eye_mod(n,m,ia,ja,ic,jc,kc,ac,max_c,ir,jr,kr,max_r, &
        iendru,iendlu,idistr,idistc,lsize,ierr)
!
! parameters
!
      integer n,m,max_r,max_c,lsize,ierr
      integer idistr,idistc,len
      integer :: ia(*),ja(*)
      integer, allocatable :: ir(:),jr(:),kr(:),ic(:),jc(:),kc(:)
      double precision, allocatable :: ac(:)
      integer iendru,iendlu
!
! include
!
! internals
!
      integer i,j,k,l,jstrt,jstop,nja
      integer izero
      double precision one
      parameter(izero=0,one=1.0d0)
!
! start of ds_eye_mod
!
!  -- test/set max_r and max_c
!
      nja=ia(n+1)-1
      len=1
      if(idistc.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(n+1)-1+n*lsize.ge.max_c-1) then
          max_c=2*nja+n*lsize
          deallocate(ac)
          allocate(ac(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_mod', &
            ' missing space to store the preconditioner',1603,2)
          deallocate(jc)
          allocate(jc(max_c),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_mod', &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
      if(idistr.eq.1) then
!
!  -- search the matrix rows
!  -- not necessary if appropriate pointers are passed from
!  -- the matrix stored in a triangle
!  -- the input matrix in ia/ja/a should be partially ordered
!
        if(ia(m+1)-1+n*lsize.ge.max_r-1) then
          max_r=2*nja+n*lsize
          deallocate(jr)
          allocate(jr(max_r),stat=ierr)
          if(ierr.ne.0) call serr(0,2,'sparslab','ds_eye_mod',  &
            ' missing space to store the preconditioner',1603,2)
        end if
      end if
!
!  -- clear vectors for row and column indices
!
      call iwset(max_r-1,izero,jr,1)
      jr(max_r)=1
      call iwset(max_c-1,izero,jc,1)
      jc(max_c)=1
!
!  -- set column pointers
!  -- and insert an unit matrix stored by columns
!
      if(idistc.eq.0.or.idistc.eq.2) then
        if(idistc.eq.0) then
          len=1
          iendlu=len*(m-1)+1
        elseif(idistc.eq.2) then
          i=max_c/3
          len=max(1,i/m)
          iendlu=len*(m-1)+1
        end if
!
!    -- set initial values in the distance len
!
        k=1
        do i=1,n
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len
        end do
      elseif(idistc.eq.1) then
        k=1
        do i=1,n
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=j-jstrt+1
              go to 130
            end if
          end do
 130 &
          continue
          ic(i)=k
          kc(i)=1
          jc(k)=i
          ac(k)=one
          k=k+len+lsize
        end do
        iendlu=k-len-lsize
      end if
      if(iendlu.ge.max_c-1) then
        stop 'internal error'
      end if
!
!  -- set row pointers
!  -- and insert row structure of the unit matrix
!
      if(idistr.eq.0.or.idistr.eq.2) then
        if(idistr.eq.0) then
          len=1
          iendru=len*(m-1)+1
        elseif(idistr.eq.2) then
          i=max_r/3
          len=max(1,i/m)
          iendru=len*(m-1)+1
        end if
!
!    -- set initial values
!
        k=1
        do i=1,m
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len
        end do
      elseif(idistr.eq.1) then
        k=1
        do i=1,m
          jstrt=ia(i)
          jstop=ia(i+1)-1
          len=jstop-jstrt+1
          do j=jstrt,jstop
            l=ja(j)
            if(l.eq.i) then
              len=jstop-j+1
              exit
            end if
          end do
          ir(i)=k
          kr(i)=1
          jr(k)=i
          k=k+len+lsize
        end do
        iendru=k-len-lsize
      end if
      if(iendru.ge.max_r-1) then
        stop 'internal error'
      end if
!
!  -- return
!
      return
!
! end of ds_eye_mod
!
      end subroutine ds_eye_mod



! (c) sparslab module name=csr2dsc_mod
!
! purpose:
!  matrix conversion from csr format
!  into dsc format with sufficient elbow space.
!
! history:
!   original version for sparslab - tu - 04/05/2001.
!
! parameters:
!   ii  n  matrix dimension.
!   oi  ia(n+1)/ja(ia(n+1)-1)/aa(ia(n+1)-1) input matrix in cs format.
!   oo  ib(n+1)/jb(ib(n+1)-1)/kb(ib(n+1)-1)/ab(ib(n+1)-1)
!         output matrix in ds format.
!
      subroutine csr2dsc_mod(n,ia,ja,aa, &
        ic,jc,kc,ac,max_c,ir,jr,kr,max_r, &
        iendru,iendlu,lsize,ierr)
!
! parameters
!
      implicit none
      integer n,max_r,max_c,lsize,ierr
      integer ia(*),ja(*)
      double precision aa(*)
      integer, allocatable :: ir(:),jr(:),kr(:),ic(:),jc(:),kc(:)
      double precision, allocatable :: ac(:)
      integer iendru,iendlu
!
! interfaces
!
!
! internals
!
      integer, allocatable, dimension(:) :: wn01
      integer i,j,k,l,jstrt,jstop,max_r_org,max_c_org,jj
      integer izero,newmax_r,newmax_c,istrt,istop,itemp,incr,incc
      integer ind
      double precision one
      parameter(izero=0,one=1.0d0)
!
! start of csr2dsc
!
!  -- allocation
!
      allocate(wn01(n+1),stat=ierr)
      if(ierr.ne.0) call serr(0,2,'sparslab','cs2ds2', &
        ' allocation error',8,2)
!
!  -- check max_r and max_c with respect to embedding of the
!  -- input matrix
!
      max_r_org=max_r
      max_c_org=max_c
      itemp=3*ia(n+1)-1
      max_r=max(max_r,itemp)
      max_c=max(max_c,itemp)
!
!  -- second check with respect to lsize
!
      max_r=max(max_r,ia(n+1)-1+n*lsize+1)
      max_c=max(max_c,ia(n+1)-1+n*lsize+1)
!
!  -- check for reallocation
!
      if(max_r_org.lt.max_r) then
!        call getincr(n,1,0,incr)
        incr=min(max_r,incr)
        incr=max(max_r-max_r_org,incr)
        if(incr.gt.0) then
          call realli_a(jr,max_r_org,incr,newmax_r,ierr)
          max_r=newmax_r
        end if
      end if
      if(max_c_org.lt.max_c) then
!        call getincr(n,1,0,incc)
        incc=min(max_r,incc)
        incc=max(max_c-max_c_org,incc)
        if(incc.gt.0) then
          call realli_a(jc,max_c_org,incc,newmax_c,ierr)
          call reallr_a(ac,max_c_org,incc,newmax_c,ierr)
          max_c=newmax_c
        end if
      end if
!
!  -- clear vectors for row and column indices
!
      call iwset(max_r-1,izero,jr,1)
      jr(max_r)=1
      call iwset(max_c-1,izero,jc,1)
      jc(max_c)=1
!
!  -- set row pointers
!
      k=1
      ind=0
      ir(1)=1
      do i=1,n
        jstrt=ia(i)
        jstop=ia(i+1)-1
        do j=jstrt,jstop
          l=ja(j)
          ind=ind+1
          jr(ind)=l
        end do
        kr(i)=jstop-jstrt+1
        ir(i+1)=ind+lsize
        ind=ind+lsize-1
      end do
      iendru=ir(n+1)-1
!
!  -- set column pointers (assumed ordering of matrix indices)
!  -- this is something like direct transposition of the input
!  -- matrix into dsc format.
!
      k=1
      ind=0
      ic(1)=1
      call iwset(n,0,wn01,1)
      call iwset(n,0,kc,1)
!
!  -- compute counts of rows
!
      jstrt=1
      do i=2,n+1
        jstop=ia(i)
        do j=jstrt,jstop-1
          jj=ja(j)
          wn01(jj)=wn01(jj)+1
        end do
        jstrt=jstop
      end do
!
!  -- get column pointers
!
      istrt=1
      ic(1)=istrt
      do j=1,n
        istop=istrt+wn01(j)
        ic(j+1)=istop+lsize
        wn01(j)=istrt
        istrt=istop+lsize
      end do
!
!  -- move the data
!
      do i=1,n
        jstrt=ia(i)
        jstop=ia(i+1)-1
        do j=jstrt,jstop
          jj=ja(j)
          k=wn01(jj)
          jc(k)=i
          ac(k)=aa(j)
          wn01(jj)=wn01(jj)+1
          kc(jj)=kc(jj)+1
        end do
      end do
      iendlu=ic(n+1)-1
!
!  -- deallocation
!
      deallocate(wn01)
!
!  -- return
!
      return
!
! end of csr2dsc_mod
!
      end subroutine csr2dsc_mod



! (c) sparslab module name=csr2sc3_mod
!
! purpose:
!  matrix conversion from csr format
!  into dsc format with no sufficient elbow space.
!  lengths of rows are not set up.
!
! history:
!   original version for sparslab - tu - 09/11/1996.
!
! parameters:
!
      subroutine csr2dsc3_mod(n,ia,ja,ic,jc,ac,max_c,ir,jr,max_r,info)
!
! parameters
!
      integer n,max_c,max_r,info
      integer :: ia(*),ja(*)
      integer, allocatable, dimension(:) :: ir,jr,ic,jc
      double precision, allocatable, dimension(:) :: ac
!
!
! internals
!
      integer, allocatable, dimension(:) :: wn01
      integer i,j,k,l,jstrt,jstop,incr,incc,newmax_r,newmax_c,itemp
      integer max_c_org,max_r_org,ierr
      double precision zero,one
      parameter(zero=0.0d0,one=1.0d0)
!
! start of csr2sc3_mod
!
!  -- allocation
!
      allocate(wn01(n+1),stat=ierr)
      if(ierr.ne.0) go to 400
!
!  -- check max_r and max_c with respect to embedding of the
!  -- input matrix
!
      max_r_org=max_r
      max_c_org=max_c
      itemp=ia(n+1)
      max_r=itemp
      max_c=itemp
!
!  -- check for reallocation
!
      if(max_r_org.lt.max_r) then
        incr=max_r-max_r_org
        call realli_a(jr,max_r,incr,newmax_r,ierr)
        max_r=newmax_r
      end if
      if(max_c_org.lt.max_c) then
        incc=max_c-max_c_org
        call realli_a(jc,max_c,incc,newmax_c,ierr)
        call reallr_a(ac,max_c,incc,newmax_c,ierr)
        max_c=newmax_c
      end if
!
! initialization
!
      call iwset(n,0,wn01,1)
      call dinit(max_c,zero,ac,1)
!
!  -- set up row pointers
!  -- and insert row structure of the upper triangle of the original matrix
!
      k=1
      do i=1,n
        ir(i)=k
        jstrt=ia(i)
        jstop=ia(i+1)-1
        do j=jstrt,jstop
          l=ja(j)
          if(l.ge.i) then
            wn01(l)=wn01(l)+1
            jr(k)=l
            k=k+1
          end if
        end do
      end do
!
!  -- set up column data structure
!
      ic(1)=1
      k=1
      do i=1,n
        ic(i+1)=k+wn01(i)
        k=ic(i+1)
      end do
      do i=1,n
        k=ic(i)
        ac(k)=one
        wn01(i)=k+1
      end do
!
      do i=1,n
        jstrt=ia(i)
        jstop=ia(i+1)-1
        do j=jstrt,jstop
          l=ja(j)
          if(l.eq.i) then
            k=ic(i)
            jc(k)=l
          elseif(l.gt.i) then
            k=wn01(l)
            jc(k)=i
            wn01(l)=k+1
          end if
        end do
      end do
!
!  -- deallocation
!
      deallocate(wn01)
!
!  -- return
!
      return
!
 400  continue
      info=8
      return
!
! end csr2sc3_mod
!
      end subroutine csr2dsc3_mod


!
      end module matrix90



      module ptools_mod
!
      use system_mod
!
      contains
!
!


! (c) sparslab module name=aicol
! purpose:
!   modify a pivot for sparse approximate inverse preconditioner ainv,
!   invert dv1
!   get a column vector wn03/wr03(1..ind3) and scale
!   a row vector wn02/wr02(1..ind2) by dv1.
!   these operations correspond to initialization
!   before sparse rank-1 update in each step
!   of the approximate inverse preconditioner procedure
!   if diag_one=1 then scale column z_i by sqrt(pivot_i)
!
! history:
!   original version for sparslab - tu - 12/04/1996.
!
! parameters:
!
      subroutine aicol(ptc,lenc,cnc,h,wn03,wr03,ind3, &
        wr02,ind2,indexc,dv1,diagtol,imodif,diag_one)
!
! parameters
!
      implicit none
      integer :: ptc(*),lenc(*),cnc(*)
      double precision :: h(*)
      integer wn03(*)
      double precision wr02(*),wr03(*)
      double precision dv1,diagtol
      integer, intent(inout) :: ind2
      integer :: ind3,indexc,imodif
      integer diag_one
!
! internals
!
      integer istrt,istop,i
      double precision zero,temp,one
      logical never
      parameter(zero=0.0d0,one=1.0d0,never=.false.)
!
! start of aicol
!
      istrt=ptc(indexc)
      istop=istrt+lenc(indexc)-1
!
!  -- test dv1 - if dv1 too small then modify
!  -- get vector wn03/wr03(1..ind3)
!
      ind3=0
      if(dv1.lt.diagtol) then
        imodif=imodif+1
        dv1=max(abs(dv1),diagtol)
      end if
      do i=istrt,istop
        ind3=ind3+1
        wn03(ind3)=cnc(i)
        wr03(ind3)=h(i)
      end do
!
!  -- invert dv1
!
      dv1=one/dv1
!
!  -- if diag_one is set then scale pivot column
!
      if(diag_one.eq.1) then
        ind3=0
        temp=sqrt(dv1)
        dv1=temp
        do i=istrt,istop
          ind3=ind3+1
          h(i)=h(i)*temp
          wr03(ind3)=h(i)
        end do
      end if
!
!  -- scale the vector wn02/wr02(1..ind2)
!
      do i=1,ind2
        wr02(i)=wr02(i)*dv1
      end do
!
!  -- return
!
      return
!
! end of aicol
!
      end subroutine aicol



!
      end module ptools_mod



      module rank1
!
      use system_mod
      use ptools_mod
      use matrix90
!
      contains
!
!


! (c) sparslab module name=rank1n2_mod
!
! purpose:
!   sparse rank-one update in dynamic data structures.
!   it updates a submatrix given by row indices
!   wn03(1..ind3) and column indices wn02(1..ind2)
!   and removes pivot column indexk and row indexj
!   from the row data structures.
!   nonsymmetric version.
!   removes processed columns from dynamic data structures.
!   advantageous for such algorithms which will not use these
!   columns later (like rif et al.)
!
!   vector wn03/wr03(1..ind3) corresponds to a pivot column.
!   input matrix is stored in the dynamic data structures
!   cnr,ptr,lenr/cnc,ptc,lenc
!
! history:
!   original version for sparslab - tu - 01/05/2001.
!   based on the codes sig.f, nig.f, aig.f, ainvupd1.f
!
      subroutine rank1n2_mod(scrlvl,n,m,ptr,cnr,lenr, &
        max_r,ptc,cnc,lenc,h,max_c, &
        indexk,wr01,wn03,wr03,ind3,wn02,wr02,ind2, &
        iendru,iendlu,drfl,nit,if2,idist,garcol,garrow,droptyp, &
        nreallocr,nreallocc,ierr,flag)
!
! parameters
!
      integer scrlvl,n,m,droptyp,nreallocr,nreallocc
      integer nit,if2,max_r,max_c
      integer, allocatable :: ptr(:),cnr(:),lenr(:),ptc(:),cnc(:),lenc(:)
      double precision, allocatable :: h(:)
      integer iendru,iendlu,nrow,garrow,garcol,indexk,ind2,ind3
      integer idist,ierr,flag
      integer wn02(*),wn03(*)
      double precision wr01(*),wr02(*),wr03(*),temp
      double precision drfl
!
! internals
!
      integer istrt,istop,ibeg,ncol,i1
      integer i,j,j1,j2,j3,iqcmpr,jstrt,jstop,incr
      integer ll1,k,len,newmax_r,newmax_c,oldmax_r,oldmax_c
      double precision zero,one,drfl_rel,avg_size
      character dropping*8
      parameter (zero=0.0d0,one=1.0d0)
!
!  -- start of rank1n2_mod
!
!  -- set dropping
!
      if(droptyp.eq.0) then
        dropping='absolute'
      elseif(droptyp.eq.1) then
        dropping='relative'
      end if
!
!  -- define new parameters
!
      ibeg=1
!
!  -- remove indexk from the rows
!  -- which intersect column indexk.
!
      istrt=ptc(indexk)
      istop=istrt+lenc(indexk)-1
      do i=istrt,istop
        k=cnc(i)
        jstrt=ptr(k)
        jstop=jstrt+lenr(k)-1
        do j=jstrt,jstop
          if(cnr(j).eq.indexk) then
            cnr(j)=cnr(jstop)
            cnr(jstop)=0
            lenr(k)=lenr(k)-1
            exit
          end if
        end do
      end do
!
!  -- main loop for columns with indices from wn02(1..ind2)
!
      do ll1=1,ind2
!
!    -- get index of the updated column and
!    -- corresponding column value of the rank-1 matrix
!
        ncol=wn02(ll1)
        temp=wr02(ll1)
!
!    -- scatter and scale the pivot column from wr03 into wr01
!
        do i=1,ind3
          j=wn03(i)
          wr01(j)=-wr03(i)*temp
        end do
!
!    -- define start and end of the column ncol
!
        istrt=ptc(ncol)
        istop=istrt+lenc(ncol)-1
!
!    -- compute average size of an original nonzero
!    -- for relative dropping
!
        if(dropping.eq.'relative') then
          avg_size=zero
          do j=istrt,istop
            temp=h(j)
            avg_size=avg_size+abs(temp)
          end do
          len=istop-istrt+1
          if(len.ne.0) then
            avg_size=avg_size/dble(len)
          end if
        end if
!
!    -- get drop tolerance
!
        if(dropping.eq.'relative') then
          drfl_rel=drfl*avg_size
        else
          drfl_rel=drfl
        end if
!
!    -- update existing entries of the column ncol
!
        do j=istrt,istop
          k=cnc(j)
          if(wr01(k).ne.zero) then
!
!        -- update
!
            h(j)=h(j)+wr01(k)
            wr01(k)=zero
            if(abs(h(j)).lt.drfl_rel) then
!
!          -- mark the value which is to be dropped
!
              cnc(j)=0
!
!          -- define start and end of the corresponding row list
!
              jstrt=ptr(k)
              jstop=jstrt+lenr(k)-1
!
!          -- find index ncol in the row list corresponding
!          -- to an entry to be dropped
!
              do i1=jstrt,jstop
                if(cnr(i1).eq.ncol) then
!
!              -- index found
!
                  cnr(i1)=cnr(jstop)
                  cnr(jstop)=0
                  lenr(k)=lenr(k)-1
!
!              -- jump outside
!
                  go to 204
                end if
              end do
 204 &
             continue
            end if
          end if
        end do
!
! -- remove marked candidates to be dropped
! -- shrink remaining entries in the column ncol between
! -- istrt and istop
!
        i=istrt
        do j=istrt,istop
          if(cnc(j).eq.0) then
            if2=if2-1
            go to 220
          else
            cnc(i)=cnc(j)
            h(i)=h(j)
            i=i+1
          end if
 220 &
         continue
        end do
        lenc(ncol)=i-istrt
        do j=i,istop
          cnc(j)=0
        end do
        istop=i-1
!
!    -- insert fill-in into column ncol
!
        do 80 i=1,ind3
          nrow=wn03(i)
!
!      -- test fill-in size
!
          if(abs(wr01(nrow)).gt.drfl_rel) then
!
!        -- look for a free space at the beginning of a column list
!
            if(istrt.gt.1) then
              if(cnc(istrt-1).eq.0) then
!
!            -- add a the new entry at the beginning of the column list
!
                istrt=istrt-1
                cnc(istrt)=nrow
                h(istrt)=wr01(nrow)
                lenc(ncol)=lenc(ncol)+1
                ptc(ncol)=ptc(ncol)-1
                if2=if2+1
                go to 550
              end if
            endif
!
!        -- look for a free space at the end of a column list
!
 400 &
            continue
            if(cnc(istop+1).eq.0) then
!
!          -- add a new element at the end of a column list
!
              iqcmpr=0
              istop=istop+1
              cnc(istop)=nrow
              h(istop)=wr01(nrow)
              if2=if2+1
              iendlu=max(iendlu,istop)
              lenc(ncol)=lenc(ncol)+1
            else
              j1=istop-istrt+1
              if((iendlu+j1).lt.max_c-1) then
!
!            -- copy a column at the current end
!            -- of the column working space
!
                j2=istrt-1-iendlu
                do j=iendlu+1,iendlu+j1
                  j3=j2+j
                  cnc(j)=cnc(j3)
                  h(j)=h(j3)
                  cnc(j3)=0
                end do
                iqcmpr=0
                istrt=iendlu+1
                ptc(ncol)=istrt
                istop=iendlu+j1
                cnc(istop+1)=0
                go to 400
              else
!
!            -- garbage collection of the column working space
!
                if(iqcmpr.eq.1.or.  &
                   (dble(iendlu)/dble(nit))*dble(n).gt.max_c) then
!
!              -- reallocation of cnc,h
!
                  oldmax_c=max_c
                  incr=min(max_c,int(0.5d0*(n*n-nit*(nit-1)/2)))
                  incr=int(min(real(max_c,8),0.5_8*(real(n,8)*real(n,8) &
                       - real(nit,8)*(real(nit,8)-1.0_8)/2)))
                  call realli_a(cnc,max_c,incr,newmax_c,ierr)
                  call reallr_a(h,max_c,incr,newmax_c,ierr)
                  max_c=newmax_c
                  nreallocc=nreallocc+1
                  call iwset1(max_c-oldmax_c+1,0,cnc,1,oldmax_c)
                  cnc(max_c)=1
                end if
                iqcmpr=1
                garcol=garcol+1
                if(scrlvl.gt.0) then
                  write(*,*) ' column garbage collection no.',garcol
                end if
                call garclds(n,ptc,cnc,lenc,h,max_c, &
                  ibeg,iendlu,nit,idist)
                istrt=ptc(ncol)
                istop=istrt+lenc(ncol)-1
                go to 400
              end if
            end if
 550 &
            continue
!
!        -- add a new index ncol into a row list corresponding to
!        -- the new fill-in position nrow
!
            jstrt=ptr(nrow)
            jstop=jstrt+lenr(nrow)-1
!
!        -- look for a free space at the beginning of a row list
!
            if(jstrt.gt.1) then
              if(cnr(jstrt-1).eq.0) then
!
!            -- add a new element at the beginning of a row list
!
                jstrt=jstrt-1
                cnr(jstrt)=ncol
                lenr(nrow)=lenr(nrow)+1
                ptr(nrow)=ptr(nrow)-1
                go to 450
              end if
            endif
!
!          -- look for a free space at the end of a row list
!
 440 &
            continue
            if(cnr(jstop+1).eq.0) then
!
!          -- add a new element at the end of a row list
!
              iqcmpr=0
              jstop=jstop+1
              cnr(jstop)=ncol
              iendru=max(iendru,jstop)
              lenr(nrow)=lenr(nrow)+1
            else
!
!          -- copy a row at the current end of the row working space
!
              j1=jstop-jstrt+1
              i1=jstrt-1-iendru
              if((iendru+j1).lt.max_r-1) then
                do 540 j2=1+iendru,j1+iendru
                  j3=i1+j2
                  cnr(j2)=cnr(j3)
                  cnr(j3)=0
 540 &
                continue
                iqcmpr=0
                jstrt=iendru+1
                ptr(nrow)=jstrt
                jstop=iendru+j1
                cnr(jstop+1)=0
                go to 440
              else
!
!            -- garbage collection of the row working space
!
                if(iqcmpr.eq.1.or. &
                   (dble(iendru)/dble(nit))*dble(n).gt.max_r) then
!
!              -- reallocation of cnr
!
                  oldmax_r=max_r
                  incr=min(max_r,int(0.5d0*(n*n-nit*(nit-1)/2)))
                  call realli_a(cnr,max_r,incr,newmax_r,ierr)
                  max_r=newmax_r
                  nreallocr=nreallocr+1
                  call iwset1(max_r-oldmax_r+1,0,cnr,1,oldmax_r)
                  cnr(max_r)=1
                end if
                iqcmpr=1
                garrow=garrow+1
                if(scrlvl.gt.0) then
                  write(*,*) ' row garbage collection no.',garrow
                end if
                call garclds2(m,ptr,cnr,lenr,max_r,ibeg, &
                  iendru,idist)
                jstrt=ptr(nrow)
                jstop=jstrt+lenr(nrow)-1
                go to 440
              end if
            end if
 450 &
            continue
          end if
!
!      -- clear nrow position in wr01
!
          wr01(nrow)=zero
!
!      -- end of fill-in cycle
!
 80  &
        continue
!
!   -- end of loop for columns
!
      end do
!
!  -- remove column indexk
!
      istrt=ptc(indexk)
      istop=istrt+lenc(indexk)-1
      do i=istrt,istop
        cnc(i)=0
      end do
      if2=if2-lenc(indexk)
      lenc(indexk)=0
      ptc(indexk)=1
!
!  -- return
!
      return
!
! end of rank1n2_mod
!
      end subroutine rank1n2_mod



!
      end module rank1



      module rif_mod
!
      use system_mod
      use matrix90
      use rank1
      use ptools_mod
!
      private
      public :: rifsrnr0, rifsr, rifsl3, rifnl, rifsl3s, rifsl4s, rifsvl

!
      contains
!
!


! (c) sparslab module name=rifsr
!
! purpose:
!  symmetric right-looking rif preconditioner based on
!  symmetric sainv preconditioner construction.
!  factorized approximate inverse is in the form: a^{-1}=z^t*d^{-1}*z,
!  where z is the lower triangular matrix stored by rows.
!
!       | *  *  .  .  .  |   | *              |   | *              |
!       |    *  .  .  ^  |   |    *           |   | *  *           |
!       |       *  .  |  | * |       *        | * | .  .  *        |
!       |          *  |  |   |          *     |   | .  .  .  *     |
!       |             *  |   |             *  |   | .  ---->    *  |
!
! a^{-1} =     z^t        *         d^{-1}     *         z
!
! history:
!   original version for sparslab - tu - 20/08/2000.
!
! parameters:
!
!   outlvl  (integer; input)  level of output messages
!                    =0  for no messages
!   ounit  (integer; input)  unit number for output messages
!   n,ia(n+1),ja(ia(n+1)-1),a(ia(n+1)-1)
!       (integer,integer,integer,double; input)  spd
!        matrix to be factorized in csr matrix format 11
!   size_c  (integer; input)  starting size for storing column
!        information in dynamic matrix storage scheme
!   size_r  (integer; input)  starting size for storing row
!        information in dynamic matrix storage scheme
!   ip(n+1),jp(ip(n+1)-1),ap(ip(n+1)-1)
!        spd rif decomposition in format 311
!   size_p  (integer; input)  starting size for storing output rif
!        factor
!   diagtol (double; input) tolerance for size of diagonal entries;
!        smaller entries are replaced by diagtol
!   drflic (double; input) drop tolerance for the rif factors
!   drflai (double; input) drop tolerance for the sainv generating process
!   droptyp (integer; input) dropping parameter controlling
!        absolute or relative dropping
!        internal value
!        =0
!   imodif (integer; output) number of modifications of diagonal
!        entries
!   filldyn (integer; output) maximum fill obtained sainv process
!   fillmax (integer; output) maximum total (sum of fill in rif
!        and in sainv) fill obtained during the process
!   ifillmax (integer; output) index where the maximum total fill
!        was obtained
!   garrow (integer; output) number of row garbage collections
!   garcol (integer; output) number of column garbage collections
!   fillic (integer; output) size of the rif factor
!   info (integer; output) output info; should be 0
!
      subroutine rifsr(outlvl,ounit,n,ia,ja,a,size_c, &
        size_r,ip,jp,ap,size_p, &
        diagtol,drflic,drflai,droptyp, &
        nrealloc,imodif, &
        filldyn,fillmax, &
        ifillmax,garrow,garcol,fillic,info)
!
! parameters
!
      integer n,outlvl,ounit,size_r,size_c,size_p
      integer garcol,garrow,droptyp,fillic
      integer imodif,filldyn,fillmax,ifillmax
      integer info,nrealloc
      integer, allocatable :: ip(:),jp(:)
      double precision, allocatable :: ap(:)
      integer ia(*),ja(*)
      double precision a(*)
      double precision drflai,drflic,diagtol
!
!
! internals
!
      integer, allocatable :: ptr(:),cnr(:),lenr(:)
      integer, allocatable :: ptc(:),cnc(:),lenc(:)
      double precision, allocatable :: h(:),diag(:)
      integer, allocatable :: wn01(:),wn02(:),wn03(:),wn04(:)
      double precision, allocatable :: wr01(:),wr02(:),wr03(:)
!
      integer ierr,flag
      integer iendru,iendlu,i,lnit
      integer totalfill,nit,indp,fill
      integer ind2,indexr,indexc,ind3,diag_one
      double precision dv1
      integer idistr,idistc,lsize,gillmur,nreallocr,nreallocc
      double precision eps,zero,one,delta,temp
      parameter(gillmur=0)
      parameter(eps=2.2d-16,zero=0.0d0,one=1.0d0,delta=1.0d-60)
      integer huge_int,incr,newsize_p
      integer, allocatable, dimension(:) :: sizes(:),sizet(:),sizep(:)
      integer, allocatable, dimension(:) :: sizez(:),sizef(:)
      logical debug
      parameter(huge_int=huge(nit))
!
! start of rifsr
!
!  -- allocation
!
      allocate(wn01(n+1),wn02(n+1),wn03(n+1),wn04(n+1),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(wr01(n+1),wr02(n+1),wr03(n+1),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(ptr(n+1),lenr(n+1),cnr(size_r),stat=ierr)
      if(ierr.ne.0) go to 400
      allocate(ptc(n+1),lenc(n+1),cnc(size_c),h(size_c),stat=ierr)
      if(ierr.ne.0) go to 400
!
!  -- allocate reallocatables
!
      allocate(ip(n+1),jp(size_p),ap(size_p),diag(n),stat=ierr)
      if(ierr.ne.0) go to 400
!
!  -- initialization
!
      diag_one=1
      debug=.false.
      if(debug) allocate(sizes(n),sizet(n),sizep(n),sizez(n),sizef(n))
      info=0
      idistr=1
      idistc=1
      lsize=5
      garcol=0
      garrow=0
      imodif=0
      nit=1
      indp=1
      ip(1)=1
      diagtol=eps
      drflai=drflai+delta
      droptyp=droptyp
      call iwset(n,0,wn01,1)
      call iwset(n,0,wn04,1)
      call dwset(n,zero,wr01,1)
!
!  -- initialize the preconditioner using dynamic matrix formats
!  -- dsr and dsc.
!
      call dsinit(n,n,ia,ja,ptc,cnc,lenc,h,size_c, &
        ptr,cnr,lenr,size_r, &
        iendru,iendlu,idistr,idistc,lsize,ierr)
      if(ierr.ne.0) stop 'error in dsinit'
!
!  -- set initial fill-in parameters
!
      fillmax=0
      fill=n
!
!  -- echo
!
      if(outlvl.ge.1) &
          write(*,*)'   compute symmetric right-looking rif preconditi', &
      'oner'
!
!  -- the loop nit=1 ...
!
  333 continue
!
!    -- find a pivot
!
        indexr=nit
        indexc=nit
        call ainvrow2(n,ia,ja,a,ptc,lenc,cnc,h,ptr,lenr,cnr, &
          wn01,wr01,wn02,wr02,wn03,wn04,ind2,indexr,dv1,drflai)
!
!    -- pivot modification and computation of updating vectors
!
        call aicol(ptc,lenc,cnc,h,wn03,wr03,ind3, &
          wr02,ind2,indexc,dv1,diagtol,imodif,diag_one)

        if(indp-1+ind2.ge.size_p) then
          incr=2*size_p
          call getincr(n,nit,size_p,incr,1,ierr)
          if(ierr.ne.0) then
            info=8
            return
          end if
          call realli_a(jp,size_p,incr,newsize_p,ierr)
          call reallr_a(ap,size_p,incr,newsize_p,ierr)
          size_p=newsize_p
          nrealloc=nrealloc+1
        end if
        jp(indp)=nit
        ap(indp)=dv1
        indp=indp+1
        do i=1,ind2
          temp=abs(wr02(i))
          if(temp.ge.drflic) then
            jp(indp)=wn02(i)
            ap(indp)=wr02(i)
            indp=indp+1
          end if
        end do
        ip(nit+1)=indp
!
!    -- save diagonal factor
!    -- this block can be considered as an anachronism because in case
!    -- that diag_one.eq.1 this array is not used and in the opposite
!    -- case use of diag can be avoided by setting diagonal elements
!    -- in factor. but we keep that as an monument of the old style
!    -- routines until new classification of preconditioner formats
!    -- is in all the routines.
!
        if(diag_one.eq.1) then
          diag(nit)=one
        else
          diag(nit)=dv1
        end if
!
!    -- test numerical and structural singularity
!
        if(indexr.le.0.or.indexc.le.0) then
          call serr(0,2,'sparslab','rifsr', &
            ' matrix is structurally singular',1041,2)
        end if
!
!    -- test whether to update
!
        if(nit.lt.n) then
!
!      -- echo
!
          if(nit/100.eq.dble(nit)/100.0d0)  write(*,*)' nit =',nit, ' fill_sainv = ',fill, &
                    ' fill_ic = ',indp-1
          if(outlvl.ne.0) then
            if(outlvl.eq.3) then
              if(nit/100.eq.dble(nit)/100.0d0) then
                if(ounit.eq.0) then
                  write(*,*)' nit =',nit, ' fill_sainv = ',fill, &
                    ' fill_ic = ',indp-1
                elseif(ounit.gt.0) then
                  write(ounit,*)' nit =',nit, ' fill_sainv = ',fill, &
                    ' fill_ic = ',indp-1
                end if
              end if
            elseif(outlvl.ge.4) then
              if(ounit.eq.0) then
                write(*,*)' nit =',nit, ' fill_sainv = ',fill, &
                  ' fill_ic = ',indp-1
              elseif(ounit.gt.0) then
                write(ounit,*)' nit =',nit, ' fill_sainv = ',fill, &
                  ' fill_ic = ',indp-1
                end if
            end if
          end if
!
!      -- sparse rank-one update
!
          if (debug) then
            if(nit > 1) sizez(nit)=sizez(nit-1)+lenc(nit)
            if(nit==1) sizez(nit)=1
          end if
          if(debug) then
            sizes(nit)=0
            do i=1,n
              sizes(nit)=sizes(nit)+lenc(i)
            end do
            sizet(nit)=sizes(nit)+indp-1
            sizep(nit)=indp-1
            sizef(nit)=iendlu+iendru
          end if
          call rank1n2_mod(outlvl,n,n,ptr,cnr,lenr, &
            size_r,ptc,cnc,lenc,h,size_c, &
            indexc,wr01,wn03,wr03,ind3,wn02,wr02,ind2, &
            iendru,iendlu,drflai,nit,fill,idistc, &
            garcol,garrow,droptyp,nreallocr,nreallocc,ierr,flag)
!
          totalfill=fill+indp-1
!
!      -- update fillmax - maximum size of reduced fill-in
!      -- which is obtained in the iteration ifillmax during the
!      -- preconditioner computation
!
          if(fillmax.lt.totalfill) then
            ifillmax=nit
            fillmax=totalfill
            filldyn=fill
          endif
          nit=nit+1
          go to 333
        end if
        fillic=indp-1
!
!  -- deallocation
!
      deallocate(wn01,wn02,wn03,wn04)
      deallocate(wr01,wr02,wr03)
      deallocate(ptr,cnr,lenr,diag)
      if(debug) then
        call ointmatl(37,n,sizes,'rifs')
        call ointmatl(37,n,sizet,'rift')
        call ointmatl(37,n,sizep,'rifp')
        call ointmatl(37,n,sizez,'rifz')
        call ointmatl(37,n,sizef,'riff')
      end if
      if(debug) deallocate(sizes,sizet,sizep,sizez)
!
!  -- return
!
      return
!
  400 continue
!
      ierr=8
      return
!
! end of rifsr
!
      end subroutine rifsr


!
      end module rif_mod

