
! (c) sparslab module name=rifsr.main
!
! purpose:
!     symmetric right-looking RIF for SPD matrices
!     a sample driver
!
!
      use rif_mod
!
      integer n,i
      double precision zero
      parameter(zero=0.0d0)
      integer msglvl,msgunit,size_r,size_c,size_l
      integer, allocatable :: il(:),jl(:)
      double precision, allocatable :: al(:)
      integer garcol,garrow,droptyp
      integer imodif,filldyn,fillmax,ifillmax,info
      integer fillic,nrealloc
      double precision drflic,drflai,diagtol
      integer, allocatable, dimension(:) :: ia,ja
      double precision, allocatable, dimension(:) :: aa,x,y
!
! start of rif_spd_right_main
!
!  -- generate input test matrix in csr format
!
      nx=7
      n=nx*nx
      nja=(4*2+(nx-2)*(nx-2)*4+4*(nx-2)*3)+n
      allocate(ia(n+1),stat=ierr)
      allocate(ja(nja),aa(nja),stat=ierr)
      call laplace(nx,ia,ja,aa)
!
!  -- get sample right-hand side
!
!
      allocate(x(n),y(n))
      do i=1,n
        x(i)=dble(i)
      end do
      call mvucsr1(n,ia,ja,aa,x,y)
!
!
!     %%%%%%%%%%%%%%%%%
!  -- to be set by user
!     %%%%%%%%%%%%%%%%%
!
!
!  -- set the drop tolerances
!  -- a/ for the final rif factor
!
      drflic=0.0d0
!
!  -- b/ for the sainv processs
!
      drflai=0.0d0
!
!     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  -- end of the part to be set by user
!     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!
!     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  -- start of defaults -- need not to be changed
!     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!  -- sizes: initial guess
!
!
      size_l=1000000
      size_r=1000000
      size_c=1000000
!
!  -- other parameters without the need to be changed
!
      diagtol=1.1d-16
      droptyp=0
!
!     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!  -- end of defaults -- need not to be changed
!     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
!
!
!  -- standard level of output
!
      msglvl=2
!
!  -- open unit for output
!
      msgunit=2
      open(unit=msgunit,file='output.out')
!
!  -- call rif
!
      call rifsr(msglvl,msgunit,n,
     *  ia,ja,aa,size_c,size_r,il,jl,al,size_l,
     *  diagtol,drflic,drflai,droptyp,nrealloc,imodif,
     *  filldyn,fillmax,ifillmax,garrow,garcol,fillic,info)
!
!  -- output preconditioner info
!
      write(2,*)' preconditioner successfully computed'
      write(2,*)' preconditioner size',fillic
      write(2,*)' pointers'
      write(2,*) il(1:n+1)
      write(2,*)' column indices'
      write(2,*) jl(1:il(n+1)-1)
      write(2,*)' nonzero entries'
      write(2,*) al(1:il(n+1)-1)
!
!  -- solve the system
!
      call bkcch(n,il,jl,al,y,x,0)
!
!  -- print solution x
!
      write(2,*)' solution x'
      write(2,*) x(1:n)
!
!  -- we have the result in y
!
      deallocate(x,y)
!
      close(2)
      stop ' success'
 400  continue
      stop ' some error'
!
! end of rif_spd_right_main
!
      end

